require "it_bit_sdk/version"
require 'active_support/all'
require 'json'
require 'rest_client'
require 'bigdecimal'
require 'digest/sha2'
require 'base64'

Dir[File.expand_path("../itBit-ruby-sdk/*.rb", __FILE__)].each {|f| require f}

module ItBitSDK
  mattr_accessor :client_key
  mattr_accessor :secret
  mattr_accessor :user_id

	extend ::ActiveSupport::Autoload

  autoload :Market

  module Trading
  	extend ::ActiveSupport::Autoload
  	autoload :Order
    autoload :Trade
  	autoload :Wallet
  end

  module Services
    module Bitcoin
      module Withdrawal
        module Request
        	extend ::ActiveSupport::Autoload
        	autoload :CheckSchedule
        end
      end
    end
  end
end
