require 'it_bit_sdk/base'
require 'it_bit_sdk/domain/ticker'
require 'it_bit_sdk/domain/order_book'
require 'it_bit_sdk/domain/trade'

module ItBitSDK
  class Market < ItBitSDK::Base
    def initialize(symbol:)
      super()

      @symbol = symbol
    end

    def ticker
      response = send_request('get', "/markets/#{@symbol}/ticker")
      ::ItBitSDK::Ticker.new(params: response)
    end

    def order_book
      response = send_request('get', "/markets/#{@symbol}/order_book")
      ::ItBitSDK::OrderBook.new(params: response)
    end

    def trades(since)
      response = send_request('get', "/markets/#{@symbol}/trades?since=#{since}")
      response['recentTrades'].collect { |trade| ::ItBitSDK::Trade.new(params: trade) }
    end
  end
end
