require 'it_bit_sdk/base'
require 'it_bit_sdk/domain/trades/trade'

module ItBitSDK
  module Trading
    class Trade < ItBitSDK::Base
      def trades(wallet_id, opts = {})
        params = {}
        %w(range_start range_end page per_page last_execution_id).each do |a|
          params[a.camelize(:lower)] = opts[a.to_sym].to_i if opts[a.to_sym]
        end

        response = send_request(:get, "/wallets/#{wallet_id}/trades", params)
        
        {
          total_number_of_records:  response['totalNumberOfRecords'].to_i,
          current_page_number:      response['currentPageNumber'].to_i,
          latest_execution_id:      response['latestExecutionId'].to_i,
          records_per_page:         response['recordsPerPage'].to_i,
          trading_history:          response['tradingHistory'].collect{|x| ::ItBitSDK::Trades::Trade::new(params: x) }
        }
      end
    end
  end
end
