require 'it_bit_sdk/base'
require 'it_bit_sdk/domain/wallet'

module ItBitSDK
  module Trading
    class Wallet < ::ItBitSDK::Base
      def wallets(page: 1, per_page: 50)
        send_request(:get, "/wallets", userId: ::ItBitSDK.user_id)
          .collect { |wallet| ::ItBitSDK::Wallet.new(params: wallet)  }
      end

      def create!(name)
        ::ItBitSDK::Wallet.new(params: send_request(:post, "/wallets", name: name, user_id: ::ItBitSDK.user_id))
      end

      def wallet(wallet_id)
        ::ItBitSDK::Wallet.new(params: send_request(:get, "/wallets/#{wallet_id}"))
      end

      def balance(wallet_id, currency_code)
        ::ItBitSDK::Wallet::Balance.new(params: send_request(:get, "/wallets/#{wallet_id}/balances/#{currency_code}"))
      end
    end
  end
end
